{ pkgs, xdg-runtime-dir }:

let
  alacritty = import ./alacritty/alacritty.nix pkgs;
in rec {
  home.packages = with pkgs; [
    fira-code ibm-plex
  ];

  programs.alacritty = alacritty;

  programs.emacs = {
    package = pkgs.emacs;
    enable = true;
    extraPackages = epkgs: with epkgs; [
      vterm bind-key rust-mode lsp-mode company meow agda2-mode haskell-mode
      terraform-mode nix-mode insert-kaomoji
    ];
    extraConfig = builtins.readFile ../dotfiles/init.el;
  };

}
