{
  pkgs,
  fox-layout,
  background-image ? "pan-wire-3.png",
  ...
}:
{
  # Enable the X11 windowing system.

  services.xserver = {
    enable = true;
    desktopManager.xfce.enable = true;
    displayManager = {
      defaultSession = "xfce";
      lightdm = {
        background = ../backgrounds/${background-image};
        greeters.slick.enable = true;
      };
    };

    layout = "fox";
    xkbOptions = "caps:escape";
    extraLayouts.fox = {
      description = "Layout suitable to be used by a fox";
      languages = ["se"];
      symbolsFile = fox-layout;
    };
  };

  console.useXkbConfig = true;

  # Enable sound.
  sound.enable = true;
  hardware.pulseaudio.enable = true;

  hardware.bluetooth.enable = true;

  users.users.xenia = {
    isNormalUser = true;
    extraGroups = [ "wheel" "docker" ];
    shell = pkgs.zsh;
  };

  environment.systemPackages = with pkgs; [
    stilo-themes

    firefox
  ];
}
